Package edu.hws.jcm.data

# Class ConditionalExpression

java.lang.Object
edu.hws.jcm.data.ConditionalExpression

All Implemented Interfaces:
  `ExpressionCommand`, `Serializable`

public class ConditionalExpression extends Object implements ExpressionCommand
A "conditional expression" is an expression using the "?" operator, such as "(x > 0)? x : -x" or "x invalid input: '<'> 3 ? 1 / (x - 3)". Note that the second case, which follows the ":", is optional. If not present, the expression has the value Double.NaN when the boolean condition evaluates to false. A ConditionalExpression object is generated by a parser when it encounters a "?" operator in the string it is parsing (provided the BOOLEANS option is turned on in that parser).

A ConditionalExpression object holds the two expressions that are the cases in a conditional expression. Note that the boolean condition is NOT stored in the ConditionalExpression object; it is part of the ExpressionProgram for the expression in which the conditional expression occurs. A ConditionalExpression is an ExpressionCommand, meaning that it can occur in an ExpressionProgram. When the apply() method in this class is called, the boolean condition has already been evaluated, and the result is on the top of the stack. The ConditionalExpression will look at this result and replace it with the value of one of the two expressions that it contains.

It is unlikely that there will be any reason for anyone to use or understand this class, except possibly as an example of an ExpressionCommand.

See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`ConditionalExpression(ExpressionProgram trueCase, ExpressionProgram falseCase)`
Create a ConditionalExpression object containing the two given expressions.

## Method Summary

Modifier and Type
Method
Description
`void`
`appendOutputString(ExpressionProgram prog, int myIndex, StringBuffer buffer)`
Append the string representation of the expression (including the boolean condition) to the buffer.
`void`
`apply(StackOfDouble stack, Cases cases)`
Apply this ConditionalExpression to the stack.
`void`
`compileDerivative(ExpressionProgram prog, int myIndex, ExpressionProgram deriv, Variable wrt)`
Add commands to deriv that evaluate the derivative of this conditional expression with respect to the variable wrt.
`boolean`
`dependsOn(Variable x)`
Returns true if x occurs in either the trueCase or the falseCase expression.
`int`
`extent(ExpressionProgram prog, int myIndex)`
Assume that this ConditionalExpression object occurs in prog at index myIndex.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ConditionalExpression

public ConditionalExpression(ExpressionProgram trueCase, ExpressionProgram falseCase)
Create a ConditionalExpression object containing the two given expressions. trueCase must not be null, but falseCase can be null.

## Method Details

### apply

public void apply(StackOfDouble stack, Cases cases)
Apply this ConditionalExpression to the stack. (Get the top item from the stack. If it is non-zero (representing a boolean value of true), evaluate trueCase and put it's value on the stack. Otherwise, evaluate falseCase and put its value on the stack. If cases is non-null, record case values for the boolean condition and for the expression that is evaluated.)

Specified by:
  `apply` in interface `ExpressionCommand`
Parameters:
  `stack` - contains results of previous commands in the program.
  `cases` - if non-null, any case information generated during evaluation should be recorded here.

### compileDerivative

public void compileDerivative(ExpressionProgram prog, int myIndex, ExpressionProgram deriv, Variable wrt)
Add commands to deriv that evaluate the derivative of this conditional expression with respect to the variable wrt. Assume that the ConditionalExpression Object occurs in the program prog at index myIndex. (The derivative of a conditional expression is another conditional expression. The boolean test for the derivative is the same as the test for this expression, so copy that test onto deriv. Than add a new ConditionalExpression object to deriv whose trueCase is the derivative of this.trueCase and whose falseCase is the derivative of this.falseCase.)

Specified by:
  `compileDerivative` in interface `ExpressionCommand`
Parameters:
  `prog` - program in which ExpressionCommand occurs.
  `myIndex` - point at which ExpressionCommand occurs in the ExpressionProgram.
  `deriv` - the derivative of the ExpressionPorgram prog, which is in the process of being computed. Commands should added to deriv that will compute the derivative of this ExpressionCommand.
  `wrt` - commands are added to deriv with respect to this Variable.

### extent

public int extent(ExpressionProgram prog, int myIndex)
Assume that this ConditionalExpression object occurs in prog at index myIndex. Compute the total number of commands in prog used by the conditional expression, including the boolean test, which occurs in prog at position myIndex-1. (The number of commands in prog used by the conditional expression is 1 (for the ConditionalExpression object itself) plus the number of commands in the boolean condition.)

Specified by:
  `extent` in interface `ExpressionCommand`
Parameters:
  `prog` - ExpressionProgram in which this ExpressionCommand occurs.
  `myIndex` - index at which ExpressionCommand occurs in prog.
Returns:
  total number of indices in prog occupied by this command and commands that generate data used by this command.

### dependsOn

public boolean dependsOn(Variable x)
Returns true if x occurs in either the trueCase or the falseCase expression.

Specified by:
  `dependsOn` in interface `ExpressionCommand`

### appendOutputString

public void appendOutputString(ExpressionProgram prog, int myIndex, StringBuffer buffer)
Append the string representation of the expression (including the boolean condition) to the buffer. Assume that this ConditionalExpression occurs as a command in prog at index myIndex (so the boolean condition starts at index myIndex-1).

Specified by:
  `appendOutputString` in interface `ExpressionCommand`